--[[
Drathals HUD2  - DHUD2
Copyright (c) 2006 by Markus Inger, 2006 by Caeryn Dryad, 2007-2008 by Horacio Hoyos

This file is part of DHUD2.

    DHUD2 is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with DHUD2.  If not, see <http://www.gnu.org/licenses/>.
]]

--Options
local L = AceLibrary("AceLocale-2.2"):new("DHUD2")
local options

--Profile Defaults
local classColors = {
    ["HUNTER"] = "ABD473", 
    ["WARLOCK"] = "9482C9",
    ["PRIEST"] = "FFFFFF",
    ["PALADIN"] = "F58CBA",
    ["MAGE"] = "69CCF0",
    ["ROGUE"] = "FFF569",
    ["DRUID"] = "FF7D0A",
    ["SHAMAN"] = "00DBBA",
    ["WARRIOR"] = "C79C6E",
}

local colors = {
    player = {
        aura = {
            color0 = { 1, 1, 1 },
            color1 = {255/255, 125/255, 125/255 },
            color2 = { 255/255, 65/255, 0 }
        },
        health = {
            color0 = { 0, 1, 0 },
            color1 = { 1, 1, 0 },
            color2 = { 1, 0, 0 }      
        },
        [0] = {
            color0 = { 0, 1, 1 },
            color1 = { 0, 0, 1 },
            color2 = { 1, 0, 1 }
        },
        [1] = {
            color0 = { 1, 0, 0 },
            color1 = { 1, 0, 0 },
            color2 = { 1, 0, 0 }
        },
        [3] = { 
            color0 = { 1, 1, 0 },
            color1 = { 1, 1, 0 },
            color2 = { 1, 1, 0 }
        },
    },
    target = {
        health = {
            color0 = { 0, 0.67, 0 },
            color1 = { 0.67, 0.67, 0 },
            color2 = { 0.67, 0, 0 }
        },
        [0] = {
            color0 = { 0, 0.67, 0.67 },
            color1 = { 0, 0, 0.67 },
            color2 = { 1, 0, 0.67 }
        },
        [1] = { 
            color0 = { 0.67, 0, 0 },
            color1 = { 0.67, 0, 0 },
            color2 = { 0.67, 0, 0 }
        },
        [3] = { 
            color0 = { 0.67, 0.67, 0 },
            color1 = { 0.67, 0.67, 0 },
            color2 = { 0.67, 0.67, 0 }
        },
        [2] = {
            color0 = { 0.67, 0.27, 0 },
            color1 = { 0.67, 0.27, 0 },
            color2 = { 0.67, 0.27, 0 }
        },
        tapped = {
            color0 = { 0.8, 0.8, 0.8 },
            color1 = { 0.73, 0.73, 0.73 },
            color2 = { 0.67, 0.67, 0.67 }
        },
    },
    pet = {
        health = {
            color0 = { 0, 1, 0 },
            color1 = { 1, 1, 0 },
            color2 = { 1, 0, 0 }
        },
        [0] = { 
            color0 = { 0, 1, 1 },
            color1 = { 0, 0, 1 },
            color2 = { 1, 0, 1 }
        },
        [2] = {
            color0 = { 0.67, 0.27, 0 },
            color1 = { 0.67, 0.27, 0 },
            color2 = { 0.67, 0.27, 0 }
        },
    },
    casting = {
        cast = { 
            color0 = { 0, 1, 0 },
            color1 = { 0.53, 1, 0 },
            color2 = { 1, 1, 0 }
        },
        channel = { 
            color0 = { 0.88, 0.88, 1 },
            color1 = { 0.75, 0.75, 0 },
            color2 = { 0.63, 0.63, 0 }
        },
    },  
    targetTarget = {
        health = {
            color0 = { 0, 0.67, 0 },
            color1 = { 0.67, 0.67, 0 },
            color2 = { 0.67, 0, 0 }
        },
        [0] = {
            color0 = { 0, 0.67, 0.67 },
            color1 = { 0, 0, 0.67 },
            color2 = { 1, 0, 0.67 }
        },
        [1] = { 
            color0 = { 0.67, 0, 0 },
            color1 = { 0.67, 0, 0 },
            color2 = { 0.67, 0, 0 }
        },
        [3] = { 
            color0 = { 0.67, 0.67, 0 },
            color1 = { 0.67, 0.67, 0 },
            color2 = { 0.67, 0.67, 0 }
        },
        [2] = {
            color0 = { 0.67, 0.27, 0 },
            color1 = { 0.67, 0.27, 0 },
            color2 = { 0.67, 0.27, 0 }
        },
        tapped = {
            color0 = { 0.8, 0.8, 0.8 },
            color1 = { 0.73, 0.73, 0.73 },
            color2 = { 0.67, 0.67, 0.67 }
        },
    },
    focus = {
        health = {
            color0 = { 0, 0.67, 0 },
            color1 = { 0.67, 0.67, 0 },
            color2 = { 0.67, 0, 0 }
        },
        [0] = {
            color0 = { 0, 0.67, 0.67 },
            color1 = { 0, 0, 0.67 },
            color2 = { 1, 0, 0.67 }
        },
        [1] = { 
            color0 = { 0.67, 0, 0 },
            color1 = { 0.67, 0, 0 },
            color2 = { 0.67, 0, 0 }
        },
        [3] = { 
            color0 = { 0.67, 0.67, 0 },
            color1 = { 0.67, 0.67, 0 },
            color2 = { 0.67, 0.67, 0 }
        },
        [2] = {
            color0 = { 0.67, 0.27, 0 },
            color1 = { 0.67, 0.27, 0 },
            color2 = { 0.67, 0.27, 0 }
        },
        tapped = {
            color0 = { 0.8, 0.8, 0.8 },
            color1 = { 0.73, 0.73, 0.73 },
            color2 = { 0.67, 0.67, 0.67 }
        },
    },
}
DHUD2:RegisterDefaults("profile", {
    gral = {
        colors = colors,
        scale = 1,
        revCasting = false,
        swapTargetAuras = false,
        playerBuffTimeFilter = 600,
    },
    show = {
        auraTips = true,
        barBorders = true,
        blizCasting = false,
        blizPet = false,
        blizPlayer = false,
        blizTarget = false,
        casting = true,
        combatIcon = true,
        druidBar = true,
        eliteIcon = true,
        npc = true,
        pet = true,
        petIcon = true,
        playerBuffs = true,
        playerPvpIcon = true,
        restIcon = true,
        targetTargetBar = true,
        focusBar = true,
        target = true,
        targetAuras = true,
        targetPvpIcon = true,
        targetTargetName = true,
    },
    layout = {
        player = "Centered",
        pet = "Centered",
        playerBars = "HL~PR",
        petBars = "HL~PR",
        druidBar = "R",
    },
    alphas = {
        combat = 1,
        ooc = 0.1,
        select = 0.6,
        regen = 0.4,
        casting = 0.8,
        dead = 0,
    },
    outlines = {
        playerBuff = "OUTLINE",
        targetName = "OUTLINE",	
        targetTargetName = "OUTLINE",
        player = "OUTLINE",
        target = "OUTLINE",
        targetTarget = "OUTLINE",
        focus = "OUTLINE",
        pet = "OUTLINE",
        castTime = "OUTLINE",
        castDelay = "OUTLINE",
    },
    fontsize = {
        playerBuff = 12,
        targetName = 12,	
        targetTargetName = 10,
        player = 10,
        target = 10,
        targetTarget = 10,
        focus = 10,
        pet = 10,
        castTime = 10,
        castDelay = 10,
    },
    styles = {
        li = "Full",
        lm = "Full",
        lo = "Full",
        lpo = "Full",
        lpi = "Full",
        ri = "Full",
        rm = "Full",
        ro = "Full",
        rpo = "Full",
        rpi = "Full",
        target = "Full",
        targetTarget = "Full",           
    },
    outer = {
        left = "TTH",
        right = "FH",
        lMod = "",
        rMod = "",
        lClick = true,
        rClick = true,
    },
})
do
    --Gral
    local function getgral(field)
		return DHUD2.db.profile.gral[field]
	end
	local function setgral(field, value)
        local p = DHUD2.db.profile
		p.gral[field] = value
        DHUD2_mainFrame:SetScale(p.gral.scale)
        DHUD2:updatePlayerAuras()
        DHUD2:updateTargetAuras(p.show.targetauras)
        if field == "scale" then
            DHUD2:setFonts()
        end
	end
	
    --Layout
    --Layouts
    local layoutType = {["Centered"] = L["Centered"], ["Right"] = L["Right"], ["Left"] = L["Left"]}
    local layoutTypeDesc = {["Centered"] = L["One bar at each side of the Player"], ["Right"] = L["Both bars to the right side"], ["Left"] = L["Both bars to the left side"]}
    local function getLayout(field)
        return DHUD2.db.profile.layout[field]
    end
    local function setLayout(field, value)
        if field == "player" then
            if value == "Centered" then
                DHUD2.db.profile.layout.playerBars = "HL~PR"
            else
                DHUD2.db.profile.layout.playerBars = "HI~PM"
            end
        end
        if field == "pet" then
            if value == "Centered" then
                DHUD2.db.profile.layout.petBars = "HL~PR"
            else
                DHUD2.db.profile.layout.petBars = "HI~PO"
            end
        end
        DHUD2.db.profile.layout[field] = value
        DHUD2:setup()
        AceLibrary("Waterfall-1.0"):Refresh('DHUD2')
    end

    --Show
    local function getshow(field)
		return DHUD2.db.profile.show[field]
	end
    local function setshow(field, value)
        local s = DHUD2.db.profile.show
        s[field] = value
        DHUD2:setup()
	end
	
    --Alphas
    local function getalpha(field)
        return DHUD2.db.profile.alphas[field]
    end
    local function setalpha(field, value)
        DHUD2.db.profile.alphas[field] = value
        DHUD2:updateAlpha()
    end
    
    --Fonts
    local maxfont = 30
    local minfont = 6
    local function getfont(field)
        return DHUD2.db.profile.fontsize[field]
    end
    local function setfont(field, value)
        DHUD2.db.profile.fontsize[field] = value
        DHUD2:setFonts()
        if field == "targetName" then
            DHUD2:updateTargetAuras(DHUD2.db.profile.show.targetAuras)
        end
    end
    
    --Outlines
    local function getout(field)
        return DHUD2.db.profile.outlines[field]
    end
    local function setout(field, value)
        DHUD2.db.profile.outlines[field] = value
        DHUD2:setFonts()
    end
    
    --Styles
    local styleValueVal = {["Full"] = "Full", ["Simple"] = "Simple", ["Small"] = "Small", ["Percent"] = "Percent", ["Minimal"] = "Minimal"}
    local styleValueDesc = {["Full"] = "<value>/<maxval><percent>", ["Simple"] = "<value>/<maxval>", ["Small"] = "<value><percent>", ["Percent"] = "<percent>", ["Minimal"] = "<value>"}
    local styleNamesVal = {["Full"] = "Full", ["Simple"] = "Simple", ["Small"] = "Small", ["Minimal"] = "Minimal"}
    local styleNamesDesc = {["Full"] = "<level><elite> <name> [ <class><pet><npc> ]", ["Simple"] = "<level><elite> <name>", ["Small"] = "<name> [ <class><pet><npc> ]", ["Minimal"] = "<level> <name>"}
    local borderVal = {"OUTLINE", "THICKOUTLINE", "OUTLINE, MONOCHROME", "THICKOUTLINE, MONOCHROME", ""}
    local borderDesc = {["OUTLINE"] = "Normal", ["THICKOUTLINE"] = "Thick", ["OUTLINE, MONOCHROME"] = "Monochrome", ["THICKOUTLINE, MONOCHROME"] = "Thick Monochrome", [""] = "None"} 
    local function getstyle(field)
        if (field == "target" or field == "targetTarget") then
            return DHUD2.db.profile.styles[field]
        else
            local bar = DHUD2.currLayout[field]
            return DHUD2.db.profile.styles[bar]
        end
    end
    local function setstyle(field, value)
        if (field == "target" or field == "targetTarget") then
            DHUD2.db.profile.styles[field] = value
        else
            local bar = DHUD2.currLayout[field]
            DHUD2.db.profile.styles[bar] = value        
        end
        DHUD2:setup()
    end
    
    -- Outer Bars
    local outerVal = {["TTH"] = "TargetTarget Health", ["TTP"] = "TargetTarget Power", ["FH"] = "Focus Health", ["FP"] = "Focus Power", [""] = "None"}
    local modifier = {["alt-"] = "Alt Key", ["ctrl-"] = "Ctrl Key", ["shift-"] = "Shift Key", [""] = "None" }
    local function getOuter(field)
        return DHUD2.db.profile.outer[field]
    end
	local function setOuter(field, value)
        DHUD2.db.profile.outer[field] = value
        DHUD2:setup()
    end
    
    --Colors
	local function getmaxcolor(field)
        return unpack(DHUD2.db.profile.gral.colors[field[1]][field[2]].color0)
	end 
    local function setmaxcolor(field, ...)
		DHUD2.db.profile.gral.colors[field[1]][field[2]].color0 = {...}
	end
	local function getmedcolor(field)
		return unpack(DHUD2.db.profile.gral.colors[field[1]][field[2]].color1)
	end   
    local function setmedcolor(field, ...)
		DHUD2.db.profile.gral.colors[field[1]][field[2]].color1 = {...}
	end	
	local function getmincolor(field)
		return unpack(DHUD2.db.profile.gral.colors[field[1]][field[2]].color2)
	end
    local function setmincolor(field, ...)
		DHUD2.db.profile.gral.colors[field[1]][field[2]].color2 = {...}
	end
	
    
    --Options table
	options = {
		type = 'group',
		args = {
			gral = {
                type = 'group',
                name = L["General"],
                desc = L["General Settings"],
                order = 100,
                args = {
                    scale = {
                        type = 'range',
						name = L["Scale"],
						desc = L["Set DHUD2's scale"],
						min = 0.2,
						max = 2,
						step = 0.1,
						get = getgral,
						set = setgral,
						order = 101,
                        passValue = "scale",
                        },
                    revCasting = {
                        type = 'toggle',
                        name = L["Reverse Castbar"],
                        desc = L["Show casting bar from full to empty"],
                        get = getgral,
						set = setgral,
                        map = { [false] = "Disabled", [true] = "Enabled" },
                        order = 102,
                        passValue = "revCasting",
                        },
                    swapTargetAuras = {
                        type = 'toggle',
                        name = L["Swap Target Auras"],
                        desc = L["Swap target auras position"],
                        get = getgral,
						set = setgral,
                        map = { [false] = "Disabled", [true] = "Enabled" },
                        order = 103,
                        passValue = "swapTargetAuras",
                        },
                    playerBuffTimeFilter = {
                        type = 'range',
						name = L["Player Buff Timer Filter"],
						desc = L["Define the time filter to show player buffs (seconds)"],
						min = 0,
						max = 600,
						step = 1,
						get = getgral,
						set = setgral,
						order = 104,
                        passValue = "playerBuffTimeFilter",
                        }
                    },
                },
            layout = {
                type = 'group',
                name = L["Layout"],
                desc = L["Choose the layout for the available bars"],
                order = 200,
                args = {
                    player = {
                        type = 'text',
                        name = L["Player Layout"],
                        desc = L["Place the Player's bars. Target's bars will be set accordingly"],
                        get = getLayout,
                        set = setLayout,
                        validate = layoutType,
                        validateDesc = layoutTypeDesc,
                        order = 201,
                        passValue = "player",
                    },                    
                    pet = {
                        type = 'text',
                        name = L["Pet Layout"],
                        desc = L["Place the pet's bars"],
                        get = getLayout,
                        set = setLayout,
                        validate = layoutType,
                        validateDesc = layoutTypeDesc,
                        order = 202,
                        passValue = "pet",
                    },
                    playerCentered = {
                        type = 'text',
                        name = L["Player Bars"],
                        desc = L["Choose health and power bars location"],
                        get = getLayout,
                        set = setLayout,
                        validate = {"HL~PR", "HR~PL"},
                        validateDesc = {["HL~PR"] = L["Health Left/Power Right"], ["HR~PL"] = L["Health Right/Power Left"]},
                        hidden = function()
                                if DHUD2.db.profile.layout.player ~= L["Centered"] then
                                    return true
                                end
                            end,
                        order = 203,
                        passValue = "playerBars",
                    },
                    playerSide = {
                        type = 'text',
                        name = L["Player Bars"],
                        desc = L["Choose health and power bars location"],
                        get = getLayout,
                        set = setLayout,
                        validate = {"HI~PM", "HM~PI"},
                        validateDesc = {["HI~PM"] = L["Health Inner/Power Outter"], ["HM~PI"] = L["Health Outter/Power Inner"]},
                        hidden = function()
                                if DHUD2.db.profile.layout.player == L["Centered"] then
                                    return true
                                end
                            end,
                        order = 204,
                        passValue = "playerBars",
                    },                    
                    petCentered = {
                        type = 'text',
                        name = L["Pet Bars"],
                        desc = L["Choose health and power bars location"],
                        get = getLayout,
                        set = setLayout,
                        validate = {"HL~PR", "HR~PL"},
                        validateDesc = {["HL~PR"] = L["Health Left/Power Right"], ["HR~PL"] = L["Health Right/Power Left"]},
                        hidden = function()
                                if DHUD2.db.profile.layout.pet ~= L["Centered"] then
                                    return true
                                end
                            end,
                        order = 205,
                        passValue = "petBars",
                    },
                    petSide = {
                        type = 'text',
                        name = L["Pet Bars"],
                        desc = L["Choose health and power bars location"],
                        get = getLayout,
                        set = setLayout,
                        validate = {"HI~PO", "HO~PI"},
                        validateDesc = {["HI~PO"] = L["Health Inner/Power Outter"], ["HO~PI"] = L["Health Outter/Power Inner"]},
                        hidden = function()
                                if DHUD2.db.profile.layout.pet == L["Centered"] then
                                    return true
                                end
                            end,
                        order = 206,
                        passValue = "petBars",
                    },
                    druid = {
                        type = 'text',
                        name = L["Druid Bar"],
                        desc = L["Choose druid mana bar location"],
                        get = getLayout,
                        set = setLayout,
                        validate = {"R", "L"},
                        validateDesc = {["R"] = L["Right side"], ["L"] = L["Left side"]},
                        hidden = function()
                                return not DHUD2.isDruid
                            end,
                        order = 207,
                        passValue = "druidBar",
                    }, 
                },
            },
            show = {
                type = 'group',
                name = L["Display"],
                desc = L["Choose what to display"],
                order = 200,
                args = {
                    blizCasting = {
                        type ='toggle',
                        name = L["Blizzard Casting Bar"],
                        desc = L["Show Blizzard casting bar"],
                        get = getshow,
						set = setshow,
                        map = { [false] = "Hide", [true] = "Show" },
                        order = 201,
                        passValue = "blizCasting",
                        },
                    blizPet = {
                        type ='toggle',
                        name = L["Blizzard Pet Bar"],
                        desc = L["Show Blizzard's pet frame"],
                        get = getshow,
						set = setshow,
                        map = { [false] = "Hide", [true] = "Show" },
                        order = 202,
                        passValue = "blizPet",
                        },
                    blizPlayer = {
                        type ='toggle',
                        name = L["Blizzard Player Frame"],
                        desc = L["Show Blizzard's player frame"],
                        get = getshow,
						set = setshow,
                        map = { [false] = "Hide", [true] = "Show" },
                        order = 203,
                        passValue = "blizPlayer",
                        },
                    blizTarget = {
                        type ='toggle',
                        name = L["Blizzard Target Frame"],
                        desc = L["Show Blizzard's target frame"],
                        get = getshow,
						set = setshow,
                        map = { [false] = "Hide", [true] = "Show" },
                        order = 204,
                        passValue = "blizTarget",
                        },
                    auraTtips = {
                        type ='toggle',
                        name = L["Aura Tips"],
                        desc = L["Show aura tips when moused over"],
                        get = getshow,
						set = setshow,
                        map = { [false] = "Hide", [true] = "Show" },
                        order = 205,
                        passValue = "auraTips",
                        },
                    barBorders = {
                        type ='toggle',
                        name = L["Bar Borders"],
                        desc = L["Show bar borders"],
                        get = getshow,
						set = setshow,
                        map = { [false] = "Hide", [true] = "Show" },
                        order = 206,
                        passValue = "barBorders",
                        },
                    casting = {
                        type ='toggle',
                        name = L["Casting Bar"],
                        desc = L["Show DHUD2 casting bar"],
                        get = getshow,
						set = setshow,
                        map = { [false] = "Hide", [true] = "Show" },
                        order = 207,
                        passValue = "casting",
                        },
                    combatIcon = {
                        type ='toggle',
                        name = L["Combat Icon"],
                        desc = L["Show combat icon"],
                        get = getshow,
						set = setshow,
                        map = { [false] = "Hide", [true] = "Show" },
                        order = 208,
                        passValue = "combatIcon",
                        },
                    druidBar = {
                        type ='toggle',
                        name = L["Druid Bar"],
                        desc = L["Show Druid's mana in pet's power bar when shape-shifted (requires SmartyCat)"],
                        get = getshow,
						set = setshow,
                        map = { [false] = "Hide", [true] = "Show" },
                        order = 209,
                        passValue = "druidBar",
                        },
                    eliteIcon = {
                        type ='toggle',
                        name = L["Elite Icon"],
                        desc = L["Show elite icon for targets"],
                        get = getshow,
						set = setshow,
                        map = { [false] = "Hide", [true] = "Show" },
                        order = 210,
                        passValue = "eliteIcon",
                        },                        
                    npc = {
                        type ='toggle',
                        name = L["Target NPCs"],
                        desc = L["Show target bars when targeting NPCs"],
                        get = getshow,
						set = setshow,
                        map = { [false] = "Hide", [true] = "Show" },
                        order = 211,
                        passValue = "npc",
                        },
                    pet = {
                        type ='toggle',
                        name = L["Player Pet"],
                        desc = L["Show player's pet bars"],
                        get = getshow,
						set = setshow,
                        map = { [false] = "Hide", [true] = "Show" },
                        order = 212,
                        passValue = "pet",
                        },
                    petIcon = {
                        type ='toggle',
                        name = L["Pet Happiness Icon"],
                        desc = L["Show pet happiness icon"],
                        get = getshow,
						set = setshow,
                        map = { [false] = "Hide", [true] = "Show" },
                        order = 213,
                        passValue = "petIcon",
                        },
                    playerBuffs = {
                        type ='toggle',
                        name = L["Player Buffs"],
                        desc = L["Show player buffs (filtered by Buff Timer Filter)"],
                        get = getshow,
						set = setshow,
                        map = { [false] = "Hide", [true] = "Show" },
                        order = 214,
                        passValue = "playerBuffs",
                        },
                    playerPvpIcon = {
                        type ='toggle',
                        name = L["Player PvP Icon"],
                        desc = L["Show player's PvP icon"],
                        get = getshow,
						set = setshow,
                        map = { [false] = "Hide", [true] = "Show" },
                        order = 215,
                        passValue = "playerPvpIcon",
                        },
                    restIcon = {
                        type ='toggle',
                        name = L["Player Rest Icon"],
                        desc = L["Show player's rest icon"],
                        get = getshow,
						set = setshow,
                        map = { [false] = "Hide", [true] = "Show" },
                        order = 216,
                        passValue = "restIcon",
                        },
                    target = {
                        type ='toggle',
                        name = L["Target Bars"],
                        desc = L["Show target bars when targeting"],
                        get = getshow,
						set = setshow,
                        map = { [false] = "Hide", [true] = "Show" },
                        order = 217,
                        passValue = "target",
                        },
                    targetAuras = {
                        type ='toggle',
                        name = L["Target Auras"],
                        desc = L["Show target auras"],
                        get = getshow,
						set = setshow,
                        map = { [false] = "Hide", [true] = "Show" },
                        order = 218,
                        passValue = "targetAuras",
                        },
                    targetPvpIcon = {
                        type ='toggle',
                        name = L["Target PvP Icon"],
                        desc = L["Show targets PvP icon"],
                        get = getshow,
						set = setshow,
                        map = { [false] = "Hide", [true] = "Show" },
                        order = 219,
                        passValue = "targetPvpIcon",
                        },
                    targetTargetName = {
                        type ='toggle',
                        name = L["Target of Target"],
                        desc = L["Show target's target text"],
                        get = getshow,
						set = setshow,
                        map = { [false] = "Hide", [true] = "Show" },
                        order = 220,
                        passValue = "targetTargetName",
                        },
                    },
                },
            alphas = {
                type = 'group',
                name = L["Alpha"],
                desc = L["Set HUD situation alpha"],
                order = 300,
                args = {
                    combat = {
                        type = 'range',
						name = L["Combat"],
						desc = L["Set HUD in combat alpha"],
						min = 0,
						max = 1,
						step = 0.05,
                        get = getalpha,
                        set = setalpha,
                        order = 301,
                        passValue = "combat",
                        },
                    ooc = {
                        type = 'range',
						name = L["Off Combat"],
						desc = L["Set HUD in out of combat alpha"],
						min = 0,
						max = 1,
						step = 0.05,
                        get = getalpha,
                        set = setalpha,
                        order = 302,
                        passValue = "ooc",
                        },
                    select = {
                        type = 'range',
						name = L["Selection"],
						desc = L["Set HUD when selecting alpha"],
						min = 0,
						max = 1,
						step = 0.05,
                        get = getalpha,
                        set = setalpha,
                        order = 303,
                        passValue = "select",
                        },
                    regen = {
                        type = 'range',
						name = L["Regeneration"],
						desc = L["Set HUD alpha when regenerating"],
						min = 0,
						max = 1,
						step = 0.05,
                        get = getalpha,
                        set = setalpha,
                        order = 304,
                        passValue = "regen",
                        },
                    casting = {
                        type = 'range',
						name = L["Casting"],
						desc = L["Set HUD alpha when casting"],
						min = 0,
						max = 1,
						step = 0.05,
                        get = getalpha,
                        set = setalpha,
                        order = 305,
                        passValue = "casting",
                        },
                    dead = {
                        type = 'range',
						name = L["Death"],
						desc = L["Set HUD alpha when dead"],
						min = 0,
						max = 1,
						step = 0.05,
                        get = getalpha,
                        set = setalpha,
                        order = 306,
                        passValue = "dead",
                        },
                    },
                },
            outlines = {
                type = 'group',
                name = L["Outlines"],
                desc = L["Show Outlines"],
                order = 400,
                args = {
                    playerBuff = {
                        type ='text',
                        name = L["Player Buffs"],
                        desc = L["Show player's buff text outline"],
                        get = getout,
						set = setout,
                        validate = borderVal,
                        validateDesc = borderDesc,
                        order = 404,
                        passValue = "playerBuff",
                        },
                    castDelay = {
                        type ='text',
                        name = L["Cast Delay"],
                        desc = L["Show cast delay text's outline"],
                        get = getout,
						set = setout,
                        validate = borderVal,
                        validateDesc = borderDesc,
                        order = 405,
                        passValue = "castDelay",
                        },
                    castTime = {
                        type ='text',
                        name = L["Cast Time"],
                        desc = L["Show cast time text's outline"],
                        get = getout,
						set = setout,
                        validate = borderVal,
                        validateDesc = borderDesc,
                        order = 406,
                        passValue = "castTime",
                        },
                    player = {
                        type ='text',
                        name = L["Player"],
                        desc = L["Show player text's outline"],
                        get = getout,
						set = setout,
                        validate = borderVal,
                        validateDesc = borderDesc,
                        order = 401,
                        passValue = "player",
                        },
                    target = {
                        type ='text',
                        name = L["Target"],
                        desc = L["Show target text's outline"],
                        get = getout,
						set = setout,
                        validate = borderVal,
                        validateDesc = borderDesc,
                        order = 402,
                        passValue = "target",
                        },
                    pet = {
                        type ='text',
                        name = L["Pet"],
                        desc = L["Show pet text's outline"],
                        get = getout,
						set = setout,
                        validate = borderVal,
                        validateDesc = borderDesc,
                        order = 403,
                        passValue = "pet",
                        },
                    targetName = {
                        type ='text',
                        name = L["Target Name"],
                        desc = L["Show target text's outline"],
                        get = getout,
						set = setout,
                        validate = borderVal,
                        validateDesc = borderDesc,
                        order = 407,
                        passValue = "targetName",
                        },
                    targetTargetName = {
                        type ='text',
                        name = L["Target Target Name"],
                        desc = L["Show target text's outline"],
                        get = getout,
						set = setout,
                        validate = borderVal,
                        validateDesc = borderDesc,
                        order = 408,
                        passValue = "targetTargetName",
                        },
                    targetTarget = {
                        type ='text',
                        name = L["Target Target"],
                        desc = L["Show target target bar text's outline"],
                        get = getout,
						set = setout,
                        validate = borderVal,
                        validateDesc = borderDesc,
                        order = 409,
                        passValue = "targetTarget",
                        },
                    focus = {
                        type ='text',
                        name = L["Focus"],
                        desc = L["Show focus bar text's outline"],
                        get = getout,
						set = setout,
                        validate = borderVal,
                        validateDesc = borderDesc,
                        order = 410,
                        passValue = "focus",
                        },
                    },
                },
            fontsize = {
                type = 'group',
                name = L["Font Sizes"],
                desc = L["Choose font size for the different texts"],
                order = 500,
                args = {
                    playerBuff = {
                        type = 'range',
                        name = L["Player Buffs"],
                        desc = L["Set player buff text font size"],
                        min = minfont,
                        max = maxfont,
                        step = 1,
                        get = getfont,
                        set = setfont,
                        order = 504,
                        passValue = "playerBuff",
                        },
                    castDelay = {
                        type = 'range',
                        name = L["Cast Delay"],
                        desc = L["Set cast delay text font size"],
                        min = minfont,
                        max = maxfont,
                        step = 1,
                        get = getfont,
                        set = setfont,
                        order = 505,
                        passValue = "castDelay",
                        },
                    castTime = {
                        type = 'range',
                        name = L["Cast Time"],
                        desc = L["Set cast time text font size"],
                        min = minfont,
                        max = maxfont,
                        step = 1,
                        get = getfont,
                        set = setfont,
                        order = 506,
                        passValue = "castTime",
                        },
                    player = {
                        type = 'range',
                        name = L["Player"],
                        desc = L["Set player health and power (mana/rage/energy) text font size"],
                        min = minfont,
                        max = maxfont,
                        step = 1,
                        get = getfont,
                        set = setfont,
                        order = 501,
                        passValue = "player",
                        },
                    target = {
                        type = 'range',
                        name = L["Target"],
                        desc = L["Set target health and power (mana/rage/energy) text font size"],
                        min = minfont,
                        max = maxfont,
                        step = 1,
                        get = getfont,
                        set = setfont,
                        order = 502,
                        passValue = "target",
                        },
                    pet = {
                        type = 'range',
                        name = L["Pet"],
                        desc = L["Set pet health and power (mana/rage/energy) text font size"],
                        min = minfont,
                        max = maxfont,
                        step = 1,
                        get = getfont,
                        set = setfont,
                        order = 503,
                        passValue = "pet",
                        },
                    targetName = {
                        type = 'range',
                        name = L["Target Name"],
                        desc = L["Set target's name text font size"],
                        min = minfont,
                        max = maxfont,
                        step = 1,
                        get = getfont,
                        set = setfont,
                        order = 507,
                        passValue = "targetName",
                        },	
                    targetTargetName = {
                        type = 'range',
                        name = L["Target Target Name"],
                        desc = L["Set target target's name text font size"],
                        min = minfont,
                        max = maxfont,
                        step = 1,
                        get = getfont,
                        set = setfont,
                        order = 508,
                        passValue = "targetTargetName",
                        },
                    targetTarget = {
                        type = 'range',
                        name = L["Target Target"],
                        desc = L["Set target target's bar text font size"],
                        min = minfont,
                        max = maxfont,
                        step = 1,
                        get = getfont,
                        set = setfont,
                        order = 509,
                        passValue = "targetTarget",
                        },
                    focus = {
                        type = 'range',
                        name = L["Focus"],
                        desc = L["Set focus's bar text font size"],
                        min = minfont,
                        max = maxfont,
                        step = 1,
                        get = getfont,
                        set = setfont,
                        order = 510,
                        passValue = "focus",
                        },
                    },
                },
            styles = {
                type = 'group',
                name = L["Text Style"],
                desc = L["Choose text style for names and health/power"],
                order = 600,
                args = {
                    playerHealth = {
                        type = 'text',
                        name = L["Player Health"],
                        desc = L["Choose text style for player's health"],
                        get = getstyle,
                        set = setstyle,
                        validate = styleValueVal,
                        validateDesc = styleValueDesc,
                        order = 601,
                        passValue = "playerHealth",
                        },
                    playerPower = {
                        type = 'text',
                        name = L["Player Power"],
                        desc = L["Choose text style for player's power (mana/rage/energy)"],
                        get = getstyle,
                        set = setstyle,
                        validate = styleValueVal,
                        validateDesc = styleValueDesc,
                        order = 602,
                        passValue = "playerPower",
                        },
                    petHealth = {
                        type = 'text',
                        name = L["Pet Health"],
                        desc = L["Choose text style for pet's health"],
                        get = getstyle,
                        set = setstyle,
                        validate = styleValueVal,
                        validateDesc = styleValueDesc,
                        order = 603,
                        passValue = "petHealth",
                        },
                    petPower = {
                        type = 'text',
                        name = L["Pet Power"],
                        desc = L["Choose text style for pet's power"],
                        get = getstyle,
                        set = setstyle,
                        validate = styleValueVal,
                        validateDesc = styleValueDesc,
                        order = 604,
                        passValue = "petPower",
                        },
                    targetHealth = {
                        type = 'text',
                        name = L["Target Health"],
                        desc = L["Choose text style for target's health"],
                        get = getstyle,
                        set = setstyle,
                        validate = styleValueVal,
                        validateDesc = styleValueDesc,
                        order = 605,
                        passValue = "targetHealth",
                        },
                    targetPower = {
                        type = 'text',
                        name = L["Target Power"],
                        desc = L["Choose text style for target's power"],
                        get = getstyle,
                        set = setstyle,
                        validate = styleValueVal,
                        validateDesc = styleValueDesc,
                        order = 606,
                        passValue = "targetHealth",
                        },
                    target = {
                        type = 'text',
                        name = L["Target Text"],
                        desc = L["Choose text style for target's text"],
                        get = getstyle,
                        set = setstyle,
                        validate = styleNamesVal,
                        validateDesc = styleNamesDesc,
                        order = 607,
                        passValue = "target",
                        },
                    targetTarget = {
                        type = 'text',
                        name = L["TargetTarget Text"],
                        desc = L["Choose text style for targetTarget's text"],
                        get = getstyle,
                        set = setstyle,
                        validate = styleNamesVal,
                        validateDesc = styleNamesDesc,
                        order = 608,
                        passValue = "targetTarget",
                        },
                    },
            },
            outerBars = {
                type = 'group',
                name = L["Outer Bars"],
                desc = L["Choose what to track on the Outer Bars"],
                order = 700,
                args = {
                    left = {
                        type ='text',
                        name = L["Left Bar"],
                        desc = L["Left bar display"],
                        get = getOuter,
						set = setOuter,
                        validate = outerVal,
                        order = 701,
                        passValue = "left",
                        },
                    right = {
                        type ='text',
                        name = L["Right Bar"],
                        desc = L["Right bar display"],
                        get = getOuter,
						set = setOuter,
                        validate = outerVal,
                        order = 704,
                        passValue = "right",
                        },
                    },
            },
            colors = {
                type = 'group',
                name = L["Colors"],
                desc = L["Change the bar colors. Choose max, medium and low colors and DHUD2 mixes them as the value of the bar changes"],
                order = 1000,
                args = {
                    playerAura = {
                        type = 'group',
                        name = L["Player Aura"],
                        desc = L["Player's aura border color"],
                        order = 1010,
                        args = {
                            color0 = {
                                type = 'color',
                                name = L["Max"],
                                desc = L["Max value color"],
                                get = getmaxcolor,
                                set = setmaxcolor,
                                order = 1011,
                                passValue = {"player", "aura"},
                                },
                            color1 = {
                                type = 'color',
                                name = L["Med"],
                                desc = L["Medium value color"],
                                get = getmedcolor,
                                set = setmedcolor,
                                order = 1012,
                                passValue = {"player", "aura"},
                                },
                            color2 = {
                                type = 'color',
                                name = L["Min"],
                                desc = L["Min value color"],
                                get = getmincolor,
                                set = setmincolor,
                                order = 1013,
                                passValue = {"player", "aura"},
                                },
                            },
                        },          
                    playerHealth = {
                        type = 'group',
                        name = L["Player Health"],
                        desc = L["Player's health color"],
                        order = 1020,
                        args = {
                            color0 = {
                                type = 'color',
                                name = L["Max"],
                                desc = L["Max value color"],
                                get = getmaxcolor,
                                set = setmaxcolor,
                                order = 1021,
                                passValue = {"player", "health"},
                                },
                            color1 = {
                                type = 'color',
                                name = L["Med"],
                                desc = L["Medium value color"],
                                get = getmedcolor,
                                set = setmedcolor,
                                order = 1022,
                                passValue = {"player", "health"},
                                },
                            color2 = {
                                type = 'color',
                                name = L["Min"],
                                desc = L["Min value color"],
                                get = getmincolor,
                                set = setmincolor,
                                order = 1023,
                                passValue = {"player", "health"},
                                },
                            },
                        },
                    playerMana = {
                        type = 'group',
                        name = L["Player Mana"],
                        desc = L["Player's mana color"],
                        order = 1030,
                        args = {
                            color0 = {
                                type = 'color',
                                name = L["Max"],
                                desc = L["Max value color"],
                                get = getmaxcolor,
                                set = setmaxcolor,
                                order = 1031,
                                passValue = {"player", 0},
                                },
                            color1 = {
                                type = 'color',
                                name = L["Med"],
                                desc = L["Medium value color"],
                                get = getmedcolor,
                                set = setmedcolor,
                                order = 1032,
                                passValue = {"player", 0},
                                },
                            color2 = {
                                type = 'color',
                                name = L["Min"],
                                desc = L["Min value color"],
                                get = getmincolor,
                                set = setmincolor,
                                order = 1033,
                                passValue = {"player", 0},
                                },
                            },
                        },
                    playerRage = {
                        type = 'group',
                        name = L["Player Rage"],
                        desc = L["Player's rage color"],
                        order = 1040,
                        args = {
                            color0 = {
                                type = 'color',
                                name = L["Max"],
                                desc = L["Max value color"],
                                get = getmaxcolor,
                                set = setmaxcolor,
                                order = 1041,
                                passValue = {"player", 1},
                                },
                            color1 = {
                                type = 'color',
                                name = L["Med"],
                                desc = L["Medium value color"],
                                get = getmedcolor,
                                set = setmedcolor,
                                order = 1042,
                                passValue = {"player", 1},
                                },
                            color2 = {
                                type = 'color',
                                name = L["Min"],
                                desc = L["Min value color"],
                                get = getmincolor,
                                set = setmincolor,
                                order = 1043,
                                passValue = {"player", 1},
                                },
                            },
                        },
                    playerEnergy = { 
                        type = 'group',
                        name = L["Player Energy"],
                        desc = L["Player's energy color"],
                        order = 1050,
                        args = {
                            color0 = {
                                type = 'color',
                                name = L["Max"],
                                desc = L["Max value color"],
                                get = getmaxcolor,
                                set = setmaxcolor,
                                order = 1051,
                                passValue = {"player", 3},
                                },
                            color1 = {
                                type = 'color',
                                name = L["Med"],
                                desc = L["Medium value color"],
                                get = getmedcolor,
                                set = setmedcolor,
                                order = 1052,
                                passValue = {"player", 3},
                                },
                            color2 = {
                                type = 'color',
                                name = L["Min"],
                                desc = L["Min value color"],
                                get = getmincolor,
                                set = setmincolor,
                                order = 1053,
                                passValue = {"player", 3},
                                },
                            },
                        },
                    targetHealth = {
                        type = 'group',
                        name = L["Target Health"],
                        desc = L["Target's health color"],
                        order = 1060,
                        args = {
                            color0 = {
                                type = 'color',
                                name = L["Max"],
                                desc = L["Max value color"],
                                get = getmaxcolor,
                                set = setmaxcolor,
                                order = 1061,
                                passValue = {"target", "health"},
                                },
                            color1 = {
                                type = 'color',
                                name = L["Med"],
                                desc = L["Medium value color"],
                                get = getmedcolor,
                                set = setmedcolor,
                                order = 1062,
                                passValue = {"target", "health"},
                                },
                            color2 = {
                                type = 'color',
                                name = L["Min"],
                                desc = L["Min value color"],
                                get = getmincolor,
                                set = setmincolor,
                                order = 1063,
                                passValue = {"target", "health"},
                                },
                            },
                        },
                    targetMana = {
                        type = 'group',
                        name = L["Target Mana"],
                        desc = L["Target's mana color"],
                        order = 1070,
                        args = {
                            color0 = {
                                type = 'color',
                                name = L["Max"],
                                desc = L["Max value color"],
                                get = getmaxcolor,
                                set = setmaxcolor,
                                order = 1071,
                                passValue = {"target", 0},
                                },
                            color1 = {
                                type = 'color',
                                name = L["Med"],
                                desc = L["Medium value color"],
                                get = getmedcolor,
                                set = setmedcolor,
                                order = 1072,
                                passValue = {"target", 0},
                                },
                            color2 = {
                                type = 'color',
                                name = L["Min"],
                                desc = L["Min value color"],
                                get = getmincolor,
                                set = setmincolor,
                                order = 1073,
                                passValue = {"target", 0},
                                },
                            },
                        },
                    targetRage = { 
                        type = 'group',
                        name = L["Target Rage"],
                        desc = L["Target's rage color"],
                        order = 1080,
                        args = {
                            color0 = {
                                type = 'color',
                                name = L["Max"],
                                desc = L["Max value color"],
                                get = getmaxcolor,
                                set = setmaxcolor,
                                order = 1081,
                                passValue = {"target", 1},
                                },
                            color1 = {
                                type = 'color',
                                name = L["Med"],
                                desc = L["Medium value color"],
                                get = getmedcolor,
                                set = setmedcolor,
                                order = 1082,
                                passValue = {"target", 1},
                                },
                            color2 = {
                                type = 'color',
                                name = L["Min"],
                                desc = L["Min value color"],
                                get = getmincolor,
                                set = setmincolor,
                                order = 1083,
                                passValue = {"target", 1},
                                },
                            },
                        },
                    targetEnergy = { 
                        type = 'group',
                        name = L["Target Energy"],
                        desc = L["Target's energy color"],
                        order = 1090,
                        args = {
                            color0 = {
                                type = 'color',
                                name = L["Max"],
                                desc = L["Max value color"],
                                get = getmaxcolor,
                                set = setmaxcolor,
                                order = 1091,
                                passValue = {"target", 3},
                                },
                            color1 = {
                                type = 'color',
                                name = L["Med"],
                                desc = L["Medium value color"],
                                get = getmedcolor,
                                set = setmedcolor,
                                order = 1092,
                                passValue = {"target", 3},
                                },
                            color2 = {
                                type = 'color',
                                name = L["Min"],
                                desc = L["Min value color"],
                                get = getmincolor,
                                set = setmincolor,
                                order = 1093,
                                passValue = {"target", 3},
                                },
                            },
                        },
                    targetFocus = {
                        type = 'group',
                        name = L["Target Focus"],
                        desc = L["Target's focus color"],
                        order = 1100,
                        args = {
                            color0 = {
                                type = 'color',
                                name = L["Max"],
                                desc = L["Max value color"],
                                get = getmaxcolor,
                                set = setmaxcolor,
                                order = 1101,
                                passValue = {"target", 2},
                                },
                            color1 = {
                                type = 'color',
                                name = L["Med"],
                                desc = L["Medium value color"],
                                get = getmedcolor,
                                set = setmedcolor,
                                order = 1102,
                                passValue = {"target", 2},
                                },
                            color2 = {
                                type = 'color',
                                name = L["Min"],
                                desc = L["Min value color"],
                                get = getmincolor,
                                set = setmincolor,
                                order = 1103,
                                passValue = {"target", 2},
                                },
                            },
                        },
                    targetTapped = {
                        type = 'group',
                        name = L["Target Tapped"],
                        desc = L["Target's tapped color"],
                        order = 1110,
                        args = {
                            color0 = {
                                type = 'color',
                                name = L["Max"],
                                desc = L["Max value color"],
                                get = getmaxcolor,
                                set = setmaxcolor,
                                order = 1111,
                                passValue = {"target", "tapped"},
                                },
                            color1 = {
                                type = 'color',
                                name = L["Med"],
                                desc = L["Medium value color"],
                                get = getmedcolor,
                                set = setmedcolor,
                                order = 1112,
                                passValue = {"target", "tapped"},
                                },
                            color2 = {
                                type = 'color',
                                name = L["Min"],
                                desc = L["Min value color"],
                                get = getmincolor,
                                set = setmincolor,
                                order = 1113,
                                passValue = {"target", "tapped"},
                                },
                            },
                        },
                    petHealth = {
                        type = 'group',
                        name = L["Pet Health"],
                        desc = L["Pet's health color"],
                        order = 1120,
                        args = {
                            color0 = {
                                type = 'color',
                                name = L["Max"],
                                desc = L["Max value color"],
                                get = getmaxcolor,
                                set = setmaxcolor,
                                order = 1121,
                                passValue = {"pet", "health"},
                                },
                            color1 = {
                                type = 'color',
                                name = L["Med"],
                                desc = L["Medium value color"],
                                get = getmedcolor,
                                set = setmedcolor,
                                order = 1122,
                                passValue = {"pet", "health"},
                                },
                            color2 = {
                                type = 'color',
                                name = L["Min"],
                                desc = L["Min value color"],
                                get = getmincolor,
                                set = setmincolor,
                                order = 1123,
                                passValue = {"pet", "health"},
                                },
                            },
                        },
                    petMana = { 
                        type = 'group',
                        name = L["Pet Mana"],
                        desc = L["Pet's mana color"],
                        order = 1130,
                        args = {
                            color0 = {
                                type = 'color',
                                name = L["Max"],
                                desc = L["Max value color"],
                                get = getmaxcolor,
                                set = setmaxcolor,
                                order = 1131,
                                passValue = {"pet", 0},
                                },
                            color1 = {
                                type = 'color',
                                name = L["Med"],
                                desc = L["Medium value color"],
                                get = getmedcolor,
                                set = setmedcolor,
                                order = 1132,
                                passValue = {"pet", 0},
                                },
                            color2 = {
                                type = 'color',
                                name = L["Min"],
                                desc = L["Min value color"],
                                get = getmincolor,
                                set = setmincolor,
                                order = 1133,
                                passValue = {"pet", 0},
                                },
                            },
                        },
                    petFocus = {
                        type = 'group',
                        name = L["Pet Focus"],
                        desc = L["Pet's focus color"],
                        order = 1140,
                        args = {
                            color0 = {
                                type = 'color',
                                name = L["Max"],
                                desc = L["Max value color"],
                                get = getmaxcolor,
                                set = setmaxcolor,
                                order = 1141,
                                passValue = {"pet", 2},
                                },
                            color1 = {
                                type = 'color',
                                name = L["Med"],
                                desc = L["Medium value color"],
                                get = getmedcolor,
                                set = setmedcolor,
                                order = 1142,
                                passValue = {"pet", 2},
                                },
                            color2 = {
                                type = 'color',
                                name = L["Min"],
                                desc = L["Min value color"],
                                get = getmincolor,
                                set = setmincolor,
                                order = 1143,
                                passValue = {"pet", 2},
                                },
                            },
                        },
                    targetTargetHealth = {
                        type = 'group',
                        name = L["Target Target Health"],
                        desc = L["Target Target's health color"],
                        order = 1150,
                        args = {
                            color0 = {
                                type = 'color',
                                name = L["Max"],
                                desc = L["Max value color"],
                                get = getmaxcolor,
                                set = setmaxcolor,
                                order = 1151,
                                passValue = {"targetTarget", "health"},
                                },
                            color1 = {
                                type = 'color',
                                name = L["Med"],
                                desc = L["Medium value color"],
                                get = getmedcolor,
                                set = setmedcolor,
                                order = 1152,
                                passValue = {"targetTarget", "health"},
                                },
                            color2 = {
                                type = 'color',
                                name = L["Min"],
                                desc = L["Min value color"],
                                get = getmincolor,
                                set = setmincolor,
                                order = 1153,
                                passValue = {"targetTarget", "health"},
                                },
                            },
                        },
                    targetTargetMana = {
                        type = 'group',
                        name = L["Target Target Mana"],
                        desc = L["Target Target's mana color"],
                        order = 1160,
                        args = {
                            color0 = {
                                type = 'color',
                                name = L["Max"],
                                desc = L["Max value color"],
                                get = getmaxcolor,
                                set = setmaxcolor,
                                order = 1161,
                                passValue = {"targetTarget", 0},
                                },
                            color1 = {
                                type = 'color',
                                name = L["Med"],
                                desc = L["Medium value color"],
                                get = getmedcolor,
                                set = setmedcolor,
                                order = 1162,
                                passValue = {"targetTarget", 0},
                                },
                            color2 = {
                                type = 'color',
                                name = L["Min"],
                                desc = L["Min value color"],
                                get = getmincolor,
                                set = setmincolor,
                                order = 1163,
                                passValue = {"targetTarget", 0},
                                },
                            },
                        },
                    targetTargetRage = { 
                        type = 'group',
                        name = L["Target Target Rage"],
                        desc = L["Target Target's rage color"],
                        order = 1170,
                        args = {
                            color0 = {
                                type = 'color',
                                name = L["Max"],
                                desc = L["Max value color"],
                                get = getmaxcolor,
                                set = setmaxcolor,
                                order = 1171,
                                passValue = {"targetTarget", 1},
                                },
                            color1 = {
                                type = 'color',
                                name = L["Med"],
                                desc = L["Medium value color"],
                                get = getmedcolor,
                                set = setmedcolor,
                                order = 1172,
                                passValue = {"targetTarget", 1},
                                },
                            color2 = {
                                type = 'color',
                                name = L["Min"],
                                desc = L["Min value color"],
                                get = getmincolor,
                                set = setmincolor,
                                order = 1173,
                                passValue = {"targetTarget", 1},
                                },
                            },
                        },
                    targetTargetEnergy = { 
                        type = 'group',
                        name = L["Target Target Energy"],
                        desc = L["Target Target's energy color"],
                        order = 1180,
                        args = {
                            color0 = {
                                type = 'color',
                                name = L["Max"],
                                desc = L["Max value color"],
                                get = getmaxcolor,
                                set = setmaxcolor,
                                order = 1181,
                                passValue = {"targetTarget", 3},
                                },
                            color1 = {
                                type = 'color',
                                name = L["Med"],
                                desc = L["Medium value color"],
                                get = getmedcolor,
                                set = setmedcolor,
                                order = 1182,
                                passValue = {"targetTarget", 3},
                                },
                            color2 = {
                                type = 'color',
                                name = L["Min"],
                                desc = L["Min value color"],
                                get = getmincolor,
                                set = setmincolor,
                                order = 1183,
                                passValue = {"targetTarget", 3},
                                },
                            },
                        },
                    targetTargetFocus = {
                        type = 'group',
                        name = L["Target Target Focus"],
                        desc = L["Target Target's focus color"],
                        order = 1190,
                        args = {
                            color0 = {
                                type = 'color',
                                name = L["Max"],
                                desc = L["Max value color"],
                                get = getmaxcolor,
                                set = setmaxcolor,
                                order = 1191,
                                passValue = {"targetTarget", 2},
                                },
                            color1 = {
                                type = 'color',
                                name = L["Med"],
                                desc = L["Medium value color"],
                                get = getmedcolor,
                                set = setmedcolor,
                                order = 1192,
                                passValue = {"targetTarget", 2},
                                },
                            color2 = {
                                type = 'color',
                                name = L["Min"],
                                desc = L["Min value color"],
                                get = getmincolor,
                                set = setmincolor,
                                order = 1193,
                                passValue = {"targetTarget", 2},
                                },
                            },
                        },
                    targetTargetTapped = {
                        type = 'group',
                        name = L["Target Target Tapped"],
                        desc = L["Target Target's tapped color"],
                        order = 1200,
                        args = {
                            color0 = {
                                type = 'color',
                                name = L["Max"],
                                desc = L["Max value color"],
                                get = getmaxcolor,
                                set = setmaxcolor,
                                order = 1201,
                                passValue = {"targetTarget", "tapped"},
                                },
                            color1 = {
                                type = 'color',
                                name = L["Med"],
                                desc = L["Medium value color"],
                                get = getmedcolor,
                                set = setmedcolor,
                                order = 1202,
                                passValue = {"targetTarget", "tapped"},
                                },
                            color2 = {
                                type = 'color',
                                name = L["Min"],
                                desc = L["Min value color"],
                                get = getmincolor,
                                set = setmincolor,
                                order = 1203,
                                passValue = {"targetTarget", "tapped"},
                                },
                            },
                        },
                    focusHealth = {
                        type = 'group',
                        name = L["Focus Health"],
                        desc = L["Focus's health color"],
                        order = 1210,
                        args = {
                            color0 = {
                                type = 'color',
                                name = L["Max"],
                                desc = L["Max value color"],
                                get = getmaxcolor,
                                set = setmaxcolor,
                                order = 1211,
                                passValue = {"focus", "health"},
                                },
                            color1 = {
                                type = 'color',
                                name = L["Med"],
                                desc = L["Medium value color"],
                                get = getmedcolor,
                                set = setmedcolor,
                                order = 1212,
                                passValue = {"focus", "health"},
                                },
                            color2 = {
                                type = 'color',
                                name = L["Min"],
                                desc = L["Min value color"],
                                get = getmincolor,
                                set = setmincolor,
                                order = 1213,
                                passValue = {"focus", "health"},
                                },
                            },
                        },
                    focusMana = {
                        type = 'group',
                        name = L["Focus Mana"],
                        desc = L["Focus's mana color"],
                        order = 1220,
                        args = {
                            color0 = {
                                type = 'color',
                                name = L["Max"],
                                desc = L["Max value color"],
                                get = getmaxcolor,
                                set = setmaxcolor,
                                order = 1221,
                                passValue = {"focus", 0},
                                },
                            color1 = {
                                type = 'color',
                                name = L["Med"],
                                desc = L["Medium value color"],
                                get = getmedcolor,
                                set = setmedcolor,
                                order = 1222,
                                passValue = {"focus", 0},
                                },
                            color2 = {
                                type = 'color',
                                name = L["Min"],
                                desc = L["Min value color"],
                                get = getmincolor,
                                set = setmincolor,
                                order = 1223,
                                passValue = {"focus", 0},
                                },
                            },
                        },
                    focusRage = { 
                        type = 'group',
                        name = L["Focus Rage"],
                        desc = L["Focus's rage color"],
                        order = 1230,
                        args = {
                            color0 = {
                                type = 'color',
                                name = L["Max"],
                                desc = L["Max value color"],
                                get = getmaxcolor,
                                set = setmaxcolor,
                                order = 1231,
                                passValue = {"focus", 1},
                                },
                            color1 = {
                                type = 'color',
                                name = L["Med"],
                                desc = L["Medium value color"],
                                get = getmedcolor,
                                set = setmedcolor,
                                order = 1232,
                                passValue = {"targetTarget", 1},
                                },
                            color2 = {
                                type = 'color',
                                name = L["Min"],
                                desc = L["Min value color"],
                                get = getmincolor,
                                set = setmincolor,
                                order = 1233,
                                passValue = {"focus", 1},
                                },
                            },
                        },
                    focusEnergy = { 
                        type = 'group',
                        name = L["Focus Energy"],
                        desc = L["Focus's energy color"],
                        order = 1240,
                        args = {
                            color0 = {
                                type = 'color',
                                name = L["Max"],
                                desc = L["Max value color"],
                                get = getmaxcolor,
                                set = setmaxcolor,
                                order = 1241,
                                passValue = {"focus", 3},
                                },
                            color1 = {
                                type = 'color',
                                name = L["Med"],
                                desc = L["Medium value color"],
                                get = getmedcolor,
                                set = setmedcolor,
                                order = 1242,
                                passValue = {"focus", 3},
                                },
                            color2 = {
                                type = 'color',
                                name = L["Min"],
                                desc = L["Min value color"],
                                get = getmincolor,
                                set = setmincolor,
                                order = 1243,
                                passValue = {"focus", 3},
                                },
                            },
                        },
                    focusFocus = {
                        type = 'group',
                        name = L["Focus Focus"],
                        desc = L["Focus's focus color"],
                        order = 1250,
                        args = {
                            color0 = {
                                type = 'color',
                                name = L["Max"],
                                desc = L["Max value color"],
                                get = getmaxcolor,
                                set = setmaxcolor,
                                order = 1251,
                                passValue = {"focus", 2},
                                },
                            color1 = {
                                type = 'color',
                                name = L["Med"],
                                desc = L["Medium value color"],
                                get = getmedcolor,
                                set = setmedcolor,
                                order = 1252,
                                passValue = {"focus", 2},
                                },
                            color2 = {
                                type = 'color',
                                name = L["Min"],
                                desc = L["Min value color"],
                                get = getmincolor,
                                set = setmincolor,
                                order = 1253,
                                passValue = {"focus", 2},
                                },
                            },
                        },
                    focusTapped = {
                        type = 'group',
                        name = L["Focus Tapped"],
                        desc = L["Focus's tapped color"],
                        order = 1260,
                        args = {
                            color0 = {
                                type = 'color',
                                name = L["Max"],
                                desc = L["Max value color"],
                                get = getmaxcolor,
                                set = setmaxcolor,
                                order = 1261,
                                passValue = {"focus", "tapped"},
                                },
                            color1 = {
                                type = 'color',
                                name = L["Med"],
                                desc = L["Medium value color"],
                                get = getmedcolor,
                                set = setmedcolor,
                                order = 1262,
                                passValue = {"focus", "tapped"},
                                },
                            color2 = {
                                type = 'color',
                                name = L["Min"],
                                desc = L["Min value color"],
                                get = getmincolor,
                                set = setmincolor,
                                order = 1263,
                                passValue = {"focus", "tapped"},
                                },
                            },
                        },
                    casting = { 
                        type = 'group',
                        name = L["Casting Bar"],
                        desc = L["Cast bar color"],
                        order = 7140,
                        args = {
                            color0 = {
                                type = 'color',
                                name = L["Max"],
                                desc = L["Max value color"],
                                get = getmaxcolor,
                                set = setmaxcolor,
                                order = 7141,
                                passValue = {"casting", "cast"},
                                },
                            color1 = {
                                type = 'color',
                                name = L["Med"],
                                desc = L["Medium value color"],
                                get = getmedcolor,
                                set = setmedcolor,
                                order = 7142,
                                passValue = {"casting", "cast"},
                                },
                            color2 = {
                                type = 'color',
                                name = L["Min"],
                                desc = L["Min value color"],
                                get = getmincolor,
                                set = setmincolor,
                                order = 7143,
                                passValue = {"casting", "cast"},
                                },
                            },
                        },
                    channelBar = { 
                        type = 'group',
                        name = L["Channel Bar"],
                        desc = L["Channel bar color"],
                        order = 7150,
                        args = {
                            color0 = {
                                type = 'color',
                                name = L["Max"],
                                desc = L["Max value color"],
                                get = getmaxcolor,
                                set = setmaxcolor,
                                order = 7151,
                                passValue = {"casting", "channel"},
                                },
                            color1 = {
                                type = 'color',
                                name = L["Med"],
                                desc = L["Medium value color"],
                                get = getmedcolor,
                                set = setmedcolor,
                                order = 7152,
                                passValue = {"casting", "channel"},
                                },
                            color2 = {
                                type = 'color',
                                name = L["Min"],
                                desc = L["Min value color"],
                                get = getmincolor,
                                set = setmincolor,
                                order = 7153,
                                passValue = {"casting", "channel"},
                                },
                            },
                        },
                    },
                },
            },
        }
	
end
DHUD2.options = options